Unit AM08R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure AM08R(var A :Array of Real; N :Integer; M :Integer;
                var B :Array of Real); 
implementation

procedure AM08R(var A :Array of Real; N :Integer; M :Integer;
                var B :Array of Real);
var
J,K,L :Integer;
R,R1,R2,T,C,S :Real;
label
_1,_2,_3;
begin
K := M-2;
if ( K <= 0 ) 
 then goto _3;
L := M-1;
_1:
J := M;
_2:
T := A[(K-1)+(J-1)*N];
R := T*T;
R1 := 1.0/(1.0+R);
C := (1.0-R)*R1;
S := (T+T)*R1;
R1 := B[L-1];
R2 := B[J-1];
B[L-1] := C*R1-S*R2;
B[J-1] := S*R1+C*R2;
J := J-1;
if ( J > L ) 
 then goto _2;
L := K;
K := K-1;
if ( K > 0 ) 
 then goto _1;
_3:
end;

end.
